HDU 1814 Peaceful Commission(2-sat 模板题输出最小字典序解决方式)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1814

Problem Description

The Public Peace Commission should be legislated in Parliament of The Democratic Republic of Byteland according to The Very Important Law. Unfortunately one of the obstacles is the fact that some deputies do not get on with some others.

The Commission has to fulfill the following conditions:

1.Each party has exactly one representative in the Commission,

2.If two deputies do not like each other, they cannot both belong to the Commission.

Each party has exactly two deputies in the Parliament. All of them are numbered from 1 to 2n. Deputies with numbers 2i-1 and 2i belong to the i-th party .

Task

Write a program, which:

1.reads from the text file SPO.IN the number of parties and the pairs of deputies that are not on friendly terms,

2.decides whether it is possible to establish the Commission, and if so, proposes the list of members,

3.writes the result in the text file SPO.OUT.

Input

In the first line of the text file SPO.IN there are two non-negative integers n and m. They denote respectively: the number of parties, 1 <= n <= 8000, and the number of pairs of deputies, who do not like each other, 0 <= m <=2 0000. In each of the following
m lines there is written one pair of integers a and b, 1 <= a < b <= 2n, separated by a single space. It means that the deputies a and b do not like each other.

There are multiple test cases. Process to end of file.

Output

The text file SPO.OUT should contain one word NIE (means NO in Polish), if the setting up of the Commission is impossible. In case when setting up of the Commission is possible the file SPO.OUT should contain n integers from the interval from 1 to 2n, written
in the ascending order, indicating numbers of deputies who can form the Commission. Each of these numbers should be written in a separate line. If the Commission can be formed in various ways, your program may write mininum number sequence.

Sample Input

3 2
1 3
2 4

Sample Output

1
4
5

Source

POI 2001

和平委员会

依据宪法,Byteland民主共和国的公众和平委员会应该在国会中通过立法程序来创立。

不幸的是,因为某些党派代表之间的不和睦而使得这件事存在障碍。

此委员会必须满足下列条件:

  • 每一个党派都在委员会中恰有1个代表,
  • 假设2个代表彼此厌恶,则他们不能都属于委员会。

每一个党在议会中有2个代表。代表从1编号到2n。

编号为2i-1和2i的代表属于第I个党派。

任务

写一程序:

  • 从文本文件读入党派的数量和关系不友好的代表对,
  • 计算决定建立和平委员会是否可能,若行,则列出委员会的成员表。
  • 结果写入文本文件。

输入

在文本文件的第一个行有2非负整数n和m。

他们各自表示:党派的数量n,1 < =n < =8000和不友好的代表对m。0 <=m <=20000。 在以下m行的每行为一对整数a,b,1<=a <b<=2n。中间用单个空格隔开。

它们表示代表a,b互相厌恶。

输出

假设委员会不能创立,文本文件里应该包含单词NIE。

若可以成立。文本文件SPO.OUT中应该包含n个从区间1到2n选出的整数。按升序写出。每行一个。这些数字为委员会中代表的编号。假设委员会能以多种方法形成,程序可以仅仅写他们的某一个。

样品输入

3 2
1 3
2 4

样品输出

1
4
5

代码例如以下:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
using namespace std;
const int MAXN = 20020;
const int MAXM = 100010;
struct Edge
{
    int to;
    int next;
} edge[MAXM];
int head[MAXN],tot;

void init()
{
    tot = 0;
    memset(head,-1,sizeof(head));
}
void addedge(int u,int v)
{
    edge[tot].to = v;
    edge[tot].next = head[u];
    head[u] = tot++;
}
bool vis[MAXN];//染色标记,为true表示选择
int S[MAXN], top;//栈

bool dfs(int u)
{
    if(vis[u^1])
        return false;
    if(vis[u])
        return true;
    vis[u] = true;
    S[top++] = u;
    for(int i = head[u]; i != -1; i = edge[i].next)
    {
        if(!dfs(edge[i].to))
            return false;
    }
    return true;
}

bool Twosat(int n)
{
    memset(vis,false,sizeof(vis));
    for(int i = 0; i < n; i += 2)
    {
        if(vis[i] || vis[i^1])continue;
        top = 0;
        if(!dfs(i))
        {
            while(top)
            {
                vis[S[--top]] = false;
            }
            if(!dfs(i^1))
                return false;
        }
    }
    return true;
}

int main()
{
    int n, m;
    int u, v;
    while(~scanf("%d%d",&n,&m))
    {
        init();
        while(m--)
        {
            scanf("%d%d",&u,&v);
            u--;
            v--;
            addedge(u,v^1);
            addedge(v,u^1);
        }
        if(Twosat(2*n))
        {
            for(int i = 0; i < 2*n; i++)
            {
                if(vis[i])
                {
                    printf("%d\n",i+1);
                }
            }
        }
        else
            printf("NIE\n");
    }
    return 0;
}
时间: 2024-10-08 01:54:33

HDU 1814 Peaceful Commission(2-sat 模板题输出最小字典序解决方式)的相关文章

HDU 1814 Peaceful Commission(2-sat 模板题输出最小字典序解)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1814 Problem Description The Public Peace Commission should be legislated in Parliament of The Democratic Republic of Byteland according to The Very Important Law. Unfortunately one of the obstacles is t

HDU 1814 Peaceful Commission(2-sat)

HDU 1814 Peaceful Commission 题目链接 题意: 根据宪法,Byteland民主共和国的公众和平委员会应该在国会中通过立法程序来创立. 不幸的是,由于某些党派代表之间的不和睦而使得这件事存在障碍. 此委员会必须满足下列条件: 每个党派都在委员会中恰有1个代表, 如果2个代表彼此厌恶,则他们不能都属于委员会. 每个党在议会中有2个代表.代表从1编号到2n. 编号为2i-1和2i的代表属于第I个党派. 任务 写一程序: 从文本文件读入党派的数量和关系不友好的代表对, 计算决

HDU 1814 Peaceful Commission

Peaceful Commission Time Limit: 5000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 181464-bit integer IO format: %I64d      Java class name: Main The Public Peace Commission should be legislated in Parliament of The Democra

hdu 1814 Peaceful Commission (2-sat 输出字典序最小路径)

Peaceful Commission Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1948    Accepted Submission(s): 560 Problem Description The Public Peace Commission should be legislated in Parliament of Th

HDU 1814 Peaceful Commission(2-sat 输出字典序最小解 )

dfs求字典序最小的2-sat解方法: 如果原图中的同一对点编号都是连续的(01.23.45--)则可以依次尝试第0对.第1对--点,每对点中先尝试编号小的,若失败再尝试编号大的.这样一定能求出字典序最小的解(如果有解的话),因为一个点一旦被确定,则不可更改. 如果原图中的同一对点编号不连续(比如03.25.14--)则按照该对点中编号小的点的编号递增顺序将每对点排序,然后依次扫描排序后的每对点,先尝试其编号小的点,若成功则将这个点选上,否则尝试编号大的点,若成功则选上,否则(都失败)无解. #

hdu 2255 二分图带权匹配 模板题

模板+注解在 http://blog.csdn.net/u011026968/article/details/38276945 hdu 2255 代码: //KM×î´ó×îСƥÅä #include <cstdio> #include <cstring> #include <algorithm> #include <iostream> using namespace std; #define INF 0x0fffffff const int MAXN

hdu 1285 确定比赛名次 (模板题)

确定比赛名次 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 11353    Accepted Submission(s): 4525 Problem Description 有N个比赛队(1<=N<=500),编号依次为1,2,3,....,N进行比赛,比赛结束后,裁判委员会要将所有参赛队伍从前往后依次排名,但现在裁判委员会不能直接

hdu 4828 Xor Sum (trie 树模板题,经典应用)

hdu 4825 题目链接 题意:给定n个数,然后给出m个询问,每组询问一个数x,问n中的数y使得x和y的异或和最大. 思路:字典树..把每个数转化成二进制,注意补全前导0,使得所有数都有相同的位数. 如果想要异或和最大,那么每一位尽可能都是1. 所以做法是,先构建字典树,然后每次find的时候,尽可能按照和当前寻找的数的位相反的位的方向走(如果有的话) 比如当前位是1,那我就往0的方向走. 需要注意的是,多组数据,每次要重新初始化一遍. 做法是 在struct 中重新 root = new N

HDOJ 1814 Peaceful Commission

经典2sat裸题,dfs的2sat能够方便输出字典序最小的解... Peaceful Commission Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1578    Accepted Submission(s): 406 Problem Description The Public Peace Commission should